diff --git a/drivers/net/ethernet/broadcom/bnxt/bnxt_ethtool.c b/drivers/net/ethernet/broadcom/bnxt/bnxt_ethtool.c
index 87eb5362ad70..9ad00240ee06 100644
--- a/drivers/net/ethernet/broadcom/bnxt/bnxt_ethtool.c
+++ b/drivers/net/ethernet/broadcom/bnxt/bnxt_ethtool.c
@@ -2022,7 +2022,8 @@ static u32 bnxt_ethtool_forced_fec_to_fw(struct bnxt_link_info *link_info,
 }
 
 static int bnxt_set_fecparam(struct net_device *dev,
-			     struct ethtool_fecparam *fecparam)
+			     struct ethtool_fecparam *fecparam,
+			     struct netlink_ext_ack *extack)
 {
 	struct hwrm_port_phy_cfg_input *req;
 	struct bnxt *bp = netdev_priv(dev);
diff --git a/drivers/net/ethernet/cavium/liquidio/lio_ethtool.c b/drivers/net/ethernet/cavium/liquidio/lio_ethtool.c
index 2c10ae3f7fc1..d6ba8153c649 100644
--- a/drivers/net/ethernet/cavium/liquidio/lio_ethtool.c
+++ b/drivers/net/ethernet/cavium/liquidio/lio_ethtool.c
@@ -3084,7 +3084,8 @@ static int lio_get_fecparam(struct net_device *netdev,
 }
 
 static int lio_set_fecparam(struct net_device *netdev,
-			    struct ethtool_fecparam *fec)
+			    struct ethtool_fecparam *fec,
+			    struct netlink_ext_ack *extack)
 {
 	struct lio *lio = GET_LIO(netdev);
 	struct octeon_device *oct = lio->oct_dev;
diff --git a/drivers/net/ethernet/chelsio/cxgb4/cxgb4_ethtool.c b/drivers/net/ethernet/chelsio/cxgb4/cxgb4_ethtool.c
index 77897edd2bc0..cd7f09aa63fb 100644
--- a/drivers/net/ethernet/chelsio/cxgb4/cxgb4_ethtool.c
+++ b/drivers/net/ethernet/chelsio/cxgb4/cxgb4_ethtool.c
@@ -834,7 +834,8 @@ static int get_fecparam(struct net_device *dev, struct ethtool_fecparam *fec)
 	return 0;
 }
 
-static int set_fecparam(struct net_device *dev, struct ethtool_fecparam *fec)
+static int set_fecparam(struct net_device *dev, struct ethtool_fecparam *fec,
+			struct netlink_ext_ack *extack)
 {
 	struct port_info *pi = netdev_priv(dev);
 	struct link_config *lc = &pi->link_cfg;
diff --git a/drivers/net/ethernet/fungible/funeth/funeth_ethtool.c b/drivers/net/ethernet/fungible/funeth/funeth_ethtool.c
index 31aa185f4d17..31b15506ca4c 100644
--- a/drivers/net/ethernet/fungible/funeth/funeth_ethtool.c
+++ b/drivers/net/ethernet/fungible/funeth/funeth_ethtool.c
@@ -1087,7 +1087,8 @@ static int fun_get_fecparam(struct net_device *netdev,
 }
 
 static int fun_set_fecparam(struct net_device *netdev,
-			    struct ethtool_fecparam *fec)
+			    struct ethtool_fecparam *fec,
+			    struct netlink_ext_ack *extack)
 {
 	struct funeth_priv *fp = netdev_priv(netdev);
 	u64 fec_mode;
diff --git a/drivers/net/ethernet/hisilicon/hns3/hns3_ethtool.c b/drivers/net/ethernet/hisilicon/hns3/hns3_ethtool.c
index 4c7988e308a2..82f7d70477e6 100644
--- a/drivers/net/ethernet/hisilicon/hns3/hns3_ethtool.c
+++ b/drivers/net/ethernet/hisilicon/hns3/hns3_ethtool.c
@@ -1673,7 +1673,8 @@ static int hns3_get_fecparam(struct net_device *netdev,
 }
 
 static int hns3_set_fecparam(struct net_device *netdev,
-			     struct ethtool_fecparam *fec)
+			     struct ethtool_fecparam *fec,
+			     struct netlink_ext_ack *extack)
 {
 	struct hnae3_handle *handle = hns3_get_handle(netdev);
 	struct hnae3_ae_dev *ae_dev = pci_get_drvdata(handle->pdev);
diff --git a/drivers/net/ethernet/intel/i40e/i40e_ethtool.c b/drivers/net/ethernet/intel/i40e/i40e_ethtool.c
index 156e92c43780..35e6eb65e237 100644
--- a/drivers/net/ethernet/intel/i40e/i40e_ethtool.c
+++ b/drivers/net/ethernet/intel/i40e/i40e_ethtool.c
@@ -1582,7 +1582,8 @@ static int i40e_get_fec_param(struct net_device *netdev,
 }
 
 static int i40e_set_fec_param(struct net_device *netdev,
-			      struct ethtool_fecparam *fecparam)
+			      struct ethtool_fecparam *fecparam,
+			      struct netlink_ext_ack *extack)
 {
 	struct i40e_netdev_priv *np = netdev_priv(netdev);
 	struct i40e_pf *pf = np->vsi->back;
diff --git a/drivers/net/ethernet/intel/ice/ice_ethtool.c b/drivers/net/ethernet/intel/ice/ice_ethtool.c
index 60dca15635db..770101577a94 100644
--- a/drivers/net/ethernet/intel/ice/ice_ethtool.c
+++ b/drivers/net/ethernet/intel/ice/ice_ethtool.c
@@ -1012,9 +1012,11 @@ static int ice_set_fec_cfg(struct net_device *netdev, enum ice_fec_mode req_fec)
  * ice_set_fecparam - Set FEC link options
  * @netdev: network interface device structure
  * @fecparam: Ethtool structure to retrieve FEC parameters
+ * @extack: Netlink extended ACK response
  */
 static int
-ice_set_fecparam(struct net_device *netdev, struct ethtool_fecparam *fecparam)
+ice_set_fecparam(struct net_device *netdev, struct ethtool_fecparam *fecparam,
+		 struct netlink_ext_ack *extack)
 {
 	struct ice_netdev_priv *np = netdev_priv(netdev);
 	struct ice_vsi *vsi = np->vsi;
diff --git a/drivers/net/ethernet/marvell/octeontx2/nic/otx2_ethtool.c b/drivers/net/ethernet/marvell/octeontx2/nic/otx2_ethtool.c
index 3f60a80e34c8..1bc5f661fe00 100644
--- a/drivers/net/ethernet/marvell/octeontx2/nic/otx2_ethtool.c
+++ b/drivers/net/ethernet/marvell/octeontx2/nic/otx2_ethtool.c
@@ -1024,7 +1024,8 @@ static int otx2_get_fecparam(struct net_device *netdev,
 }
 
 static int otx2_set_fecparam(struct net_device *netdev,
-			     struct ethtool_fecparam *fecparam)
+			     struct ethtool_fecparam *fecparam,
+			     struct netlink_ext_ack *extack)
 {
 	struct otx2_nic *pfvf = netdev_priv(netdev);
 	struct mbox *mbox = &pfvf->mbox;
diff --git a/drivers/net/ethernet/marvell/prestera/prestera_ethtool.c b/drivers/net/ethernet/marvell/prestera/prestera_ethtool.c
index 1da7ff889417..4f19f0dfac5e 100644
--- a/drivers/net/ethernet/marvell/prestera/prestera_ethtool.c
+++ b/drivers/net/ethernet/marvell/prestera/prestera_ethtool.c
@@ -705,7 +705,8 @@ static int prestera_ethtool_get_fecparam(struct net_device *dev,
 }
 
 static int prestera_ethtool_set_fecparam(struct net_device *dev,
-					 struct ethtool_fecparam *fecparam)
+					 struct ethtool_fecparam *fecparam,
+					 struct netlink_ext_ack *extack)
 {
 	struct prestera_port *port = netdev_priv(dev);
 	struct prestera_port_mac_config cfg_mac;
diff --git a/drivers/net/ethernet/mellanox/mlx5/core/en_ethtool.c b/drivers/net/ethernet/mellanox/mlx5/core/en_ethtool.c
index b811207fe5ed..1e2b82aff1cb 100644
--- a/drivers/net/ethernet/mellanox/mlx5/core/en_ethtool.c
+++ b/drivers/net/ethernet/mellanox/mlx5/core/en_ethtool.c
@@ -1668,7 +1668,8 @@ static int mlx5e_get_fecparam(struct net_device *netdev,
 }
 
 static int mlx5e_set_fecparam(struct net_device *netdev,
-			      struct ethtool_fecparam *fecparam)
+			      struct ethtool_fecparam *fecparam,
+			      struct netlink_ext_ack *extack)
 {
 	struct mlx5e_priv *priv = netdev_priv(netdev);
 	struct mlx5_core_dev *mdev = priv->mdev;
diff --git a/drivers/net/ethernet/netronome/nfp/nfp_net_ethtool.c b/drivers/net/ethernet/netronome/nfp/nfp_net_ethtool.c
index eeb1455a4e5d..4c29da87c61f 100644
--- a/drivers/net/ethernet/netronome/nfp/nfp_net_ethtool.c
+++ b/drivers/net/ethernet/netronome/nfp/nfp_net_ethtool.c
@@ -1015,7 +1015,8 @@ nfp_port_get_fecparam(struct net_device *netdev,
 
 static int
 nfp_port_set_fecparam(struct net_device *netdev,
-		      struct ethtool_fecparam *param)
+		      struct ethtool_fecparam *param,
+		      struct netlink_ext_ack *extack)
 {
 	struct nfp_eth_table_port *eth_port;
 	struct nfp_port *port;
diff --git a/drivers/net/ethernet/pensando/ionic/ionic_ethtool.c b/drivers/net/ethernet/pensando/ionic/ionic_ethtool.c
index 01c22701482d..d9ff8899c67c 100644
--- a/drivers/net/ethernet/pensando/ionic/ionic_ethtool.c
+++ b/drivers/net/ethernet/pensando/ionic/ionic_ethtool.c
@@ -360,7 +360,8 @@ static int ionic_get_fecparam(struct net_device *netdev,
 }
 
 static int ionic_set_fecparam(struct net_device *netdev,
-			      struct ethtool_fecparam *fec)
+			      struct ethtool_fecparam *fec,
+			      struct netlink_ext_ack *extack)
 {
 	struct ionic_lif *lif = netdev_priv(netdev);
 	u8 fec_type;
diff --git a/drivers/net/ethernet/qlogic/qede/qede_ethtool.c b/drivers/net/ethernet/qlogic/qede/qede_ethtool.c
index 97a7ab0826ed..db3aab14907e 100644
--- a/drivers/net/ethernet/qlogic/qede/qede_ethtool.c
+++ b/drivers/net/ethernet/qlogic/qede/qede_ethtool.c
@@ -1912,7 +1912,8 @@ static int qede_get_fecparam(struct net_device *dev,
 }
 
 static int qede_set_fecparam(struct net_device *dev,
-			     struct ethtool_fecparam *fecparam)
+			     struct ethtool_fecparam *fecparam,
+			     struct netlink_ext_ack *extack)
 {
 	struct qede_dev *edev = netdev_priv(dev);
 	struct qed_link_params params;
diff --git a/drivers/net/ethernet/sfc/ethtool_common.c b/drivers/net/ethernet/sfc/ethtool_common.c
index bc840ede3053..2b1b505da4fb 100644
--- a/drivers/net/ethernet/sfc/ethtool_common.c
+++ b/drivers/net/ethernet/sfc/ethtool_common.c
@@ -616,7 +616,8 @@ int efx_ethtool_get_fecparam(struct net_device *net_dev,
 }
 
 int efx_ethtool_set_fecparam(struct net_device *net_dev,
-			     struct ethtool_fecparam *fecparam)
+			     struct ethtool_fecparam *fecparam,
+			     struct netlink_ext_ack *extack)
 {
 	struct efx_nic *efx = efx_netdev_priv(net_dev);
 	int rc;
diff --git a/drivers/net/ethernet/sfc/ethtool_common.h b/drivers/net/ethernet/sfc/ethtool_common.h
index 659491932101..4cdc322f4616 100644
--- a/drivers/net/ethernet/sfc/ethtool_common.h
+++ b/drivers/net/ethernet/sfc/ethtool_common.h
@@ -37,7 +37,8 @@ int efx_ethtool_set_link_ksettings(struct net_device *net_dev,
 int efx_ethtool_get_fecparam(struct net_device *net_dev,
 			     struct ethtool_fecparam *fecparam);
 int efx_ethtool_set_fecparam(struct net_device *net_dev,
-			     struct ethtool_fecparam *fecparam);
+			     struct ethtool_fecparam *fecparam,
+			     struct netlink_ext_ack *extack);
 int efx_ethtool_get_rxnfc(struct net_device *net_dev,
 			  struct ethtool_rxnfc *info, u32 *rule_locs);
 int efx_ethtool_set_rxnfc(struct net_device *net_dev,
diff --git a/drivers/net/ethernet/sfc/siena/ethtool_common.c b/drivers/net/ethernet/sfc/siena/ethtool_common.c
index 0207d07f54e3..9f65cb1c058c 100644
--- a/drivers/net/ethernet/sfc/siena/ethtool_common.c
+++ b/drivers/net/ethernet/sfc/siena/ethtool_common.c
@@ -616,7 +616,8 @@ int efx_siena_ethtool_get_fecparam(struct net_device *net_dev,
 }
 
 int efx_siena_ethtool_set_fecparam(struct net_device *net_dev,
-				   struct ethtool_fecparam *fecparam)
+				   struct ethtool_fecparam *fecparam,
+				   struct netlink_ext_ack *extack)
 {
 	struct efx_nic *efx = netdev_priv(net_dev);
 	int rc;
diff --git a/drivers/net/ethernet/sfc/siena/ethtool_common.h b/drivers/net/ethernet/sfc/siena/ethtool_common.h
index 04b375dc6800..7dadd95eb69f 100644
--- a/drivers/net/ethernet/sfc/siena/ethtool_common.h
+++ b/drivers/net/ethernet/sfc/siena/ethtool_common.h
@@ -34,7 +34,8 @@ int efx_siena_ethtool_set_link_ksettings(struct net_device *net_dev,
 int efx_siena_ethtool_get_fecparam(struct net_device *net_dev,
 				   struct ethtool_fecparam *fecparam);
 int efx_siena_ethtool_set_fecparam(struct net_device *net_dev,
-				   struct ethtool_fecparam *fecparam);
+				   struct ethtool_fecparam *fecparam,
+				   struct netlink_ext_ack *extack);
 int efx_siena_ethtool_get_rxnfc(struct net_device *net_dev,
 				struct ethtool_rxnfc *info, u32 *rule_locs);
 int efx_siena_ethtool_set_rxnfc(struct net_device *net_dev,
diff --git a/drivers/net/netdevsim/ethtool.c b/drivers/net/netdevsim/ethtool.c
index ffd9f84b6644..88f3738c5899 100644
--- a/drivers/net/netdevsim/ethtool.c
+++ b/drivers/net/netdevsim/ethtool.c
@@ -124,7 +124,8 @@ nsim_get_fecparam(struct net_device *dev, struct ethtool_fecparam *fecparam)
 }
 
 static int
-nsim_set_fecparam(struct net_device *dev, struct ethtool_fecparam *fecparam)
+nsim_set_fecparam(struct net_device *dev, struct ethtool_fecparam *fecparam,
+		  struct netlink_ext_ack *extack)
 {
 	struct netdevsim *ns = netdev_priv(dev);
 	u32 fec;
diff --git a/include/linux/ethtool.h b/include/linux/ethtool.h
index 99dc7bfbcd3c..3ce1ef7b1390 100644
--- a/include/linux/ethtool.h
+++ b/include/linux/ethtool.h
@@ -735,7 +735,8 @@ struct ethtool_ops {
 	int	(*get_fecparam)(struct net_device *,
 				      struct ethtool_fecparam *);
 	int	(*set_fecparam)(struct net_device *,
-				      struct ethtool_fecparam *);
+				      struct ethtool_fecparam *,
+				      struct netlink_ext_ack *extack);
 	void	(*get_ethtool_phy_stats)(struct net_device *,
 					 struct ethtool_stats *, u64 *);
 	int	(*get_phy_tunable)(struct net_device *,
diff --git a/net/ethtool/fec.c b/net/ethtool/fec.c
index 9f5a134e2e01..79931b0de177 100644
--- a/net/ethtool/fec.c
+++ b/net/ethtool/fec.c
@@ -295,7 +295,7 @@ int ethnl_set_fec(struct sk_buff *skb, struct genl_info *info)
 		goto out_ops;
 	}
 
-	ret = dev->ethtool_ops->set_fecparam(dev, &fec);
+	ret = dev->ethtool_ops->set_fecparam(dev, &fec, info->extack);
 	if (ret < 0)
 		goto out_ops;
 	ethtool_notify(dev, ETHTOOL_MSG_FEC_NTF, NULL);
diff --git a/net/ethtool/ioctl.c b/net/ethtool/ioctl.c
index 6a7308de192d..2f397d016d3a 100644
--- a/net/ethtool/ioctl.c
+++ b/net/ethtool/ioctl.c
@@ -2706,7 +2706,7 @@ static int ethtool_set_fecparam(struct net_device *dev, void __user *useraddr)
 	fecparam.active_fec = 0;
 	fecparam.reserved = 0;
 
-	return dev->ethtool_ops->set_fecparam(dev, &fecparam);
+	return dev->ethtool_ops->set_fecparam(dev, &fecparam, NULL);
 }
 
 /* The main entry point in this file.  Called from net/core/dev_ioctl.c */